\chapter{Conclusion}
\label{chap:conclusion}
The primary goal was to modernize the central \gls{XMPP}/Jabber-Server of the RWTH Aachen University,
i.\,e.\ to turn it into an attractive \gls{IM} system up-to-date with modern internet standards with as little interference to the operating \gls{XMPP} service as possible.
The secondary goal was to (re-)implement the long-lost feature of managing shared roster groups by normal users without administrator privileges.
After exploring the basics of \gls{XMPP} along with its history and application areas today and discussing what additional software was necessary,
the old system was somewhat improved before a completely new system has been set up and all user accounts and their data were migrated.
The switch to a recent \gls{XMPP} server software on a new \gls{OS} was completed successfully within three hours early in the morning
by leveraging the strengths of Ansible,
an IT automation tool.
The resulting migration scripts as well as the Ansible playbook have been published on github.com so other people facing the same tasks might re-use them.
The Ansible playbook is also an exact set of instructions regarding the system's setup,
documenting step by step how to turn a minimal default installation of Debian GNU/Linux into the full-blown \gls{XMPP}/Jabber-Server that is jabber.rwth-aachen.de.
The modernized system now supports the latest security protocols and is fully compliant with modern \gls{XMPP} standards,
including support for mobile devices (e.\,g.\ stream resumption and push notifications).

The homepage of jabber.rwth-aachen.de is completely new with a fresh look,
lists up-to-date \gls{GTC} in English and German and was extended for allowing the users to manage shared roster groups themselves
(see \cref{fig:groups-edit}).
The new website is based on the web framework \emph{Django},
the Django \emph{groups} app for managing shared roster groups was written from scratch and consists of approximately 2,000 lines of source code and text.
It too was written in English,
translated to German,
and published on github.com.
The old PHP based website is shown in \cref{fig:hp-old},
the new Django based website can be seen live on \url{https://jabber.rwth-aachen.de}
and in \cref{fig:hp-new}.
The new website offers many features the old one was lacking:
\begin{itemize}[itemsep=0pt]
	\item support for multiple languages (English and German)
	\item users can choose the localpart of their \gls{JID} freely
	\item the system is not limited to members of the RWTH Aachen University anymore, it accepts members of all the Aachen universities
	\item unused accounts automatically expire after one year and are consequently deleted
	\item users can log in and log out of their accounts on the website
	\item users can see their list of current \gls{XMPP} sessions and terminate sessions individually
	\item users can see their list of \gls{HTTP} uploads and delete elements individually
	\item users can create, list, edit, and delete shared roster groups
	\item users can change their e-mail addresses
	\item users can upload GPG keys and then receive all e-mails from the server fully encrypted
	\item users can configure whether they want to receive notifications regarding expiring accounts and/or GPG keys
	\item users can see a list of their recent account activity, which includes all of the above
\end{itemize}

\begin{figure}[htbp]
 \includegraphics[width=1\textwidth]{screenshots/hp_old}
 \caption{Old website of jabber.rwth-aachen.de}
 \label{fig:hp-old}
\end{figure}

\begin{figure}[htbp]
 \includegraphics[width=1\textwidth]{screenshots/hp_new}
 \caption{New website of jabber.rwth-aachen.de}
 \label{fig:hp-new}
\end{figure}

The available data and the received feedback give strong indications that no users were driven away by the change,
instead the usability and with it the user satisfaction has increased significantly.
The estimated increase in active users due to this thesis is over 30\%.
This shows that with some effort it is no problem to run a modern \gls{XMPP} server purely on \gls{FOSS}.
The new \gls{XMPP}/Jabber-Server is one of few servers known that achieve both full compliance and top scores on xmpp.net (see \cref{chap:evaluation} for details).

In order to maintain this remarkable level of quality,
the \gls{XMPP} server software on jabber.rwth-aachen.de should be updated once or twice a year
and the \gls{OS} should be updated to the next long term support release every 2--5 years.
Once IPv6 network connectivity becomes available,
a \gls{DNS} record for the assigned IPv6 address should be registered with the IT Center's nameservers and ejabberd should be configured to use IPv6 by default and IPv4 as fallback.

A possible extension to jabber.rwth-aachen.de would be to host an \gls{XMPP} web client,
e.\,g.\ Movim or converse.js,
to avoid users having to install a special \gls{XMPP} client software on their devices in order to use the provided services.

